(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(['models/letter', 'collections/letters', 'views/list/create', 'views/header/header', 'views/list/list', 'views/footer/footer', 'controllers/create_letter'], function(Letter, Letters, CreateLetterButtonView, HeaderView, ListView, FooterView, CreateLetterController) {
    var ListController, _ref;
    return ListController = (function(_super) {
      __extends(ListController, _super);

      function ListController() {
        _ref = ListController.__super__.constructor.apply(this, arguments);
        return _ref;
      }

      ListController.prototype.initialize = function(_arg) {
        this.vent = _arg.vent, this.regions = _arg.regions;
        this.letters = new Letters();
        return this.letters.fetch();
      };

      ListController.prototype.show = function(type) {
        var createLetterButtonView, lettersVirtualCollection, listView;
        lettersVirtualCollection = new Backbone.VirtualCollection(this.letters, {
          filter: function(letter) {
            if (type != null) {
              return letter.get('type') === type;
            } else {
              return true;
            }
          }
        });
        createLetterButtonView = new CreateLetterButtonView();
        listView = new ListView({
          collection: lettersVirtualCollection
        });
        this.listenTo(createLetterButtonView, 'letter:new', function() {
          var createLetterController;
          createLetterController = new CreateLetterController({
            regions: this.regions,
            letters: this.letters
          });
          return createLetterController.show();
        });
        this.listenTo(listView, 'itemview:letter:delete', function(view, model) {
          return this.letters.remove(model);
        });
        this.regions.topMenu.show(createLetterButtonView);
        this.regions.header.show(new HeaderView());
        this.regions.content.show(listView);
        return this.regions.footer.show(new FooterView());
      };

      return ListController;

    })(Marionette.Controller);
  });

}).call(this);
