define [
  'models/letter',
  'collections/letters',
  'views/header/header', 'views/create/index', 'views/footer/footer'
],
(
  Letter,
  Letters,
  HeaderView, CreateLetterView, FooterView
) ->

  class CreateLetterController extends Marionette.Controller

    initialize: ({ @vent, @regions, @letters }) ->
      @letter = new Letter()

    perform: (formData) ->
      @letters.create formData

    show: ->
      createLetterView = new CreateLetterView model: @letter

      @listenTo createLetterView, 'submitted', @perform

      @regions.topMenu.close()
      @regions.header.show  new HeaderView()
      @regions.content.show createLetterView
      @regions.footer.show  new FooterView()