define [
  'models/letter',
  'collections/letters',
  'views/list/create', 'views/header/header', 'views/list/list', 'views/footer/footer',
  'controllers/create_letter'
],
(
  Letter,
  Letters,
  CreateLetterButtonView, HeaderView, ListView, FooterView,
  CreateLetterController
) ->

  class ListController extends Marionette.Controller

    initialize: ({ @vent, @regions }) ->
      @letters = new Letters()
      @letters.fetch()
      # @letters.seed() unless @letters.length < 3 # Сидируем если в хранилище мало писем. Для наглядности

    show: (type) ->
      lettersVirtualCollection = new Backbone.VirtualCollection @letters,
        filter: (letter) ->
          if type?
            letter.get('type') is type
          else
            true
      createLetterButtonView = new CreateLetterButtonView()
      listView = new ListView collection: lettersVirtualCollection

      @listenTo createLetterButtonView, 'letter:new', ->
        createLetterController = new CreateLetterController
          regions: @regions
          letters: @letters
        createLetterController.show()
      
      @listenTo listView, 'itemview:letter:delete', (view, model) ->
        @letters.remove model

      @regions.topMenu.show createLetterButtonView
      @regions.header.show  new HeaderView()
      @regions.content.show listView
      @regions.footer.show  new FooterView()