define [
  'controllers/list', 'controllers/show'
],
(
  ListController, ShowController
) ->

  class AppRouter extends Backbone.Router

    initialize: ({ @vent, @regions }) ->
      @on 'route', (name) =>
        console.log "Route is #{name}"

    routes:
      '': 'showUnsortedList'
      'show/:id':    'showLetter'
      'list/:type': 'showListWithType'

    showUnsortedList: ->
      listController = new ListController
        vent:    @vent
        regions: @regions
      listController.show()

    showListWithType: (type) ->
      listController = new ListController
        vent:    @vent
        regions: @regions
      listController.show type

    showLetter: (id) ->
      showController = new ShowController
        id:      id
        vent:    @vent
        regions: @regions
      showController.show()